import { BaseCustomWebComponentLazyAppend, TypedEvent } from '@node-projects/base-custom-webcomponent';
import { ICodeView, IDisposable, IUiCommand, IStringPosition } from '@node-projects/web-component-designer';
export declare class CodeViewCodeMirror5 extends BaseCustomWebComponentLazyAppend implements ICodeView, IDisposable {
    canvasElement: HTMLElement;
    elementsToPackages: Map<string, string>;
    code: string;
    onTextChanged: TypedEvent<string>;
    mode: string;
    private _codeMirrorEditor;
    private _editor;
    static readonly style: CSSStyleSheet;
    static readonly template: HTMLTemplateElement;
    constructor();
    dispose(): void;
    executeCommand(command: IUiCommand): void;
    canExecuteCommand(command: IUiCommand): boolean;
    focusEditor(): void;
    ready(): void;
    update(code: any): void;
    getText(): any;
    setSelection(position: IStringPosition): void;
}
